volatile uint8_t compass_data[2];

#include <Wire.h> //I2C Arduino Library
#define address 0x1E //0011110b, I2C 7bit address of HMC5883

void compass_begin(void) {
  //GY-273
  Wire.begin();
  Wire.beginTransmission(address); //open communication with HMC5883
  Wire.write(0x02); //select mode register
  Wire.write(0x00); //continuous measurement mode
  Wire.endTransmission();
}

void compass_get(void) {
  //Serial.println(Angleread()) ;          // 方位角を返す
  int raw_data = Angleread();
  if (raw_data > 255) {
    compass_data[0] = 255;
    compass_data[1] = raw_data - 255;
  } else {
    compass_data[0] = raw_data;
    compass_data[1] = 0;
  }
}
int Angleread() {
  int x, y, z; //triple axis data
  Wire.beginTransmission(address);
  Wire.write(0x03); //select register 3, X MSB register
  Wire.endTransmission();
  Wire.requestFrom(address, 6);
  if (6 <= Wire.available()) {
    x = Wire.read() << 8; //X msb
    x |= Wire.read(); //X lsb
    z = Wire.read() << 8; //Z msb
    z |= Wire.read(); //Z lsb
    y = Wire.read() << 8; //Y msb
    y |= Wire.read(); //Y lsb
  }
  //return atan2((x - 100) , (y + 500) * (-1)) * RAD_TO_DEG + 180; //40と20は補正値
  return atan2((x - 90) , (y + 110) * (-1)) * RAD_TO_DEG + 180; //40と20は補正値
}
